#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <linux/kthread.h>
#include <linux/semaphore.h>

int count;
DEFINE_SEMAPHORE(sem);
struct task_struct *read_thread, *write_thread;

#define SLEEP_MS 500

static int write_func(void *data)
{
  while (!kthread_should_stop()) {
    down(&sem);
    count++;
    up(&sem);
    msleep(SLEEP_MS);
  }

  do_exit(0);
}

static int read_func(void *data)
{
  while (!kthread_should_stop()) {
    down(&sem);
    printk("count = %d\n", count);
    up(&sem);
    msleep(SLEEP_MS);
  }

  do_exit(0);
}

static int __init semaphore_kernel_module_init(void)
{
  printk("semaphore_kernel_module_init()\n");
  count = 0;
  sema_init(&sem, 1);
  read_thread = kthread_run(read_func, NULL, "read-thread");
  write_thread = kthread_run(write_func, NULL, "write-thread");
  return 0;
}

static void __exit semaphore_kernel_module_exit(void)
{
  printk("semaphore_kernel_module_exit()\n");
  kthread_stop(read_thread);
  kthread_stop(write_thread);
}

module_init(semaphore_kernel_module_init);
module_exit(semaphore_kernel_module_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Hiroyuki Chishiro");
MODULE_DESCRIPTION("Semaphore Kernel Module");
